#include "LCD.h"
#include "Main.h"
#include "Port.h"
#include "SPI.h"

uint8_t Page_Counter = 0, Column_Counter = 0, LSB_Counter = 0, MSB_Counter = 0;
uint8_t DelayCntr=0;



const uint8_t Image_0[]=
{
    6, 16,
  224, 16, 24,  8,240,  0,  3,  4,  4,  4,  3,  0
};
const uint8_t Image_1[] =
{
    6, 16,
    0, 32, 48,248,  0,  0,  0,  0,  0,  7,  0,  0
};
const uint8_t Image_2[] =
{
    6, 16,
    0, 48,  8,136,112,  0,  0,  6,  3,  4,  2,  0
};
const uint8_t Image_3[] =
{
    6, 16,
   48, 40, 72, 72,176,  0,  3,  4,  4,  4,  3,  0
};
const uint8_t Image_4[] =
{
    6, 16,
    0,128, 96,248,  0,128,  1,  1,  1,  7,  1,  0
};
const uint8_t Image_5[] =
{
    6, 16,
    0,120, 80, 80,136,  0,  3,  5,  4,  4,  3,  0
};
const uint8_t Image_6[] =
{
    6, 16,
    0,224, 80, 72, 72,136,  0,  3,  4,  4,  4,  3
};
const uint8_t Image_7[] =
{
    6, 16,
    0, 24,136, 72, 56,  8,  0,  0,  7,  6,  0,  0
};
const uint8_t Image_8[] =
{
    6, 16,
  176, 72, 72,200,176,  0,  3,  4,  4,  4,  3,  0
};
const uint8_t Image_9[] =
{
    6, 16,
    0,112,136,136, 72,240,  0,  4,  4,  4,  2,  1
};
const uint8_t Image_dp[] =
{
    3, 16,
    0,128,  0,  0, 13,  0
};
//const uint8_t FrenchScriptMT_Zahlen_und_DP[][]
//{
//	// 0:
//	{6, 16,
//  224, 16, 24,  8,240,  0,  3,  4,  4,  4,  3,  0},
//  
//	// 1:
//	{    6, 16,
//    0, 32, 48,248,  0,  0,  0,  0,  0,  7,  0,  0},
//    
//	// 2:
//	{     6, 16,
//    0, 48,  8,136,112,  0,  0,  6,  3,  4,  2,  0},  
//    
//    // 3:
//    {    6, 16,
//   48, 40, 72, 72,176,  0,  3,  4,  4,  4,  3,  0},
//
//	// 4:
//    {6, 16,
//    0,128, 96,248,  0,128,  1,  1,  1,  7,  1,  0},
//    
//    // 5:
//    {
//    6, 16,
//    0,120, 80, 80,136,  0,  3,  5,  4,  4,  3,  0}
//    
//};

void PrintCharOnLCD(uint8_t *Zeichensatz, uint8_t ch, uint8_t x)
{
	if (ch >= 48 && ch <=58)
	{
		// "ch" befindet sich innerhalb der aktuellen Range.
		uint8_t index = 0;
		index = ch - 48;
		
		DiplayImage(Zeichensatz[index], x, 0);
	}
	else
	{
		// "ch" befindet sich auerhalb der aktuellen Range.
	}
}

void DisplayImage(uint8_t * Image, uint8_t x, uint8_t y)
{
	uint8_t C_cntr = 0, P_cntr = 0;
	uint8_t lsb = 0, msb = 0; 
	uint16_t index_cntr = 0;
	uint8_t temp = 0;
	uint8_t ca = 0;
	
	asm("NOP");
	
	temp 	= x * 8;
	ca 		= temp;
	
	for (P_cntr = 0; P_cntr < (Image[1]/8); P_cntr++)
	{
		
		// LCD command: set page address
		SPIsend(0xB0 + P_cntr, LCD );
		ca = temp;
		// x kann sein: von 0-12
		for (C_cntr = 0; C_cntr < (Image[0]); C_cntr++ )
		{	
			
				lsb 	= ca & 0xF;
				msb 	= ca >> 4;

				// LCD command: set column address
				SPIsend(0x00 + lsb, LCD);	
				SPIsend(0x10 + msb, LCD);
				WDB(Image[(index_cntr)+2]);
				

			

			ca++;	
			index_cntr++;
		}
	}
}


// Davor muss SPI initialisiert werden.
void InitLCD(void)
{
    ANSELH = 0;
    
    LCD_RESET_TRIS  = OUTPUT;
    LCD_RESET_PIN   = ON;

    LCD_CD_TRIS     = OUTPUT;
    LCD_CD_PIN      = OFF;

    LCD_SS_TRIS     = OUTPUT;
    LCD_SS_PIN      = ON;
    
	SPIsend(0x40, LCD); //Startline 0
	SPIsend(0xA1, LCD); //SEG reverse
	SPIsend(0xC0, LCD); //Set COM direction (COM0-COM63)
	SPIsend(0xA4, LCD); //Set all Pixel to on
	SPIsend(0xA6, LCD); //Display inverse off
	SPIsend(0xA2, LCD); //Set bias 1/9
	SPIsend(0x2F, LCD); //Booster, regulator, follower on
	SPIsend(0x27, LCD); //Set contrast
	SPIsend(0x81, LCD); //Set contrast
	SPIsend(0x10, LCD); //Set contrast
	SPIsend(0xFA, LCD); //Temperature compensation
	SPIsend(0x90, LCD); //Temperature compensation
	SPIsend(0xAF, LCD); //Display on

}
void WDB(uint8_t d)
{
    
    CD = ON;

    SPIsend(d, LCD);

    CD = OFF;
    
}
void LCD_clear(void)
{
// LCD DDRAM lschen
    for (Column_Counter = 1; Column_Counter <=102; Column_Counter++)
    {
        
        
        for (Page_Counter = 0; Page_Counter < 8; Page_Counter++)
        {
			
			// LCD: Set Page Address
			SPIsend(0xB0 + Page_Counter, LCD);
			// LCD: Set Column Address LSB
            SPIsend(0x00 + LSB_Counter, LCD);
			// LCD: Set Column Address MSB
            SPIsend(0x10 + MSB_Counter, LCD);
            
			WDB(0x00);

        }
        if ((LSB_Counter++ == 15) && MSB_Counter <= 7)
        {
        	LSB_Counter = 0;
            MSB_Counter++;
        }
		
    }
}
